# Use the official Python Docker image
image: python:latest

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

cache:
  paths:
    - .cache/pip

before_script:
  - python --version && pip --version
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

stages:
  - test
  - documentation
  - deploy

test:
  stage: test
  script:
    - pip install pytest pytest-cov
    - pip install -r requirements.txt
    - pip install -e .
    - PYTHONPATH=$(pwd) pytest --junitxml=report.xml --cov=sagace --cov-report xml:coverage.xml --cov-report term
  artifacts:
    when: always
    reports:
      junit: report.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
  coverage: '/TOTAL\s+\d+\s+\d+\s+(\d+%)/'

documentation:
  stage: documentation
  script:
    # Install dependencies for deployment
    - pip install sphinx sphinx-rtd-theme myst-parser

    # Generate Sphinx documentation
    - cd docs
    - make clean
    - make html
    - mv build/html/ ../public/
  artifacts:
    paths:
      - public

deploy:
  stage: deploy
  script:
    # Install dependencies for deployment
    - pip install build twine
    # Build and publish the package to PyPI
    - rm -rf dist build  # Clean old builds
    - python -m build
    - twine check dist/* # Verify the package metadata before upload
    - twine upload --repository $PYPI_REPOSITORY dist/*
  artifacts:
    paths:
      - public
  only:
    - main  # Garante que o deploy ocorre apenas na branch principal
  environment:
    name: production
